// Generated from libavfilter/opencl/bwdif.cl
const char *ff_source_bwdif_cl =
"/*\n"
" * Copyright (C) 2019 Philip Langdale <philipl@overt.org>\n"
" * Copyright (C) 2025 NyanMisaka\n"
" *\n"
" * This file is part of FFmpeg.\n"
" *\n"
" * FFmpeg is free software; you can redistribute it and/or\n"
" * modify it under the terms of the GNU Lesser General Public\n"
" * License as published by the Free Software Foundation; either\n"
" * version 2.1 of the License, or (at your option) any later version.\n"
" *\n"
" * FFmpeg is distributed in the hope that it will be useful,\n"
" * but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU\n"
" * Lesser General Public License for more details.\n"
" *\n"
" * You should have received a copy of the GNU Lesser General Public\n"
" * License along with FFmpeg; if not, write to the Free Software\n"
" * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA\n"
" */\n"
"\n"
"#define max3(a, b, c) max(max((a), (b)), (c))\n"
"#define min3(a, b, c) min(min((a), (b)), (c))\n"
"\n"
"__constant sampler_t sampler = (CLK_NORMALIZED_COORDS_FALSE |\n"
"                                CLK_ADDRESS_CLAMP_TO_EDGE   |\n"
"                                CLK_FILTER_NEAREST);\n"
"\n"
"__constant float coef_lf[2] = { 4309.0f, 213.0f };\n"
"__constant float coef_hf[3] = { 5570.0f, 3801.0f, 1016.0f };\n"
"__constant float coef_sp[2] = { 5077.0f, 981.0f };\n"
"\n"
"#define FILTER_INTRA(T) \\\n"
"inline T filter_intra_##T(T cur_prefs3, T cur_prefs, \\\n"
"                          T cur_mrefs, T cur_mrefs3) \\\n"
"{ \\\n"
"    T final = native_divide((coef_sp[0] * (cur_mrefs + cur_prefs) - \\\n"
"                             coef_sp[1] * (cur_mrefs3 + cur_prefs3)), (float)(1 << 13)); \\\n"
"    return clamp(final, 0.0f, 1.0f); \\\n"
"}\n"
"\n"
"FILTER_INTRA(float)\n"
"FILTER_INTRA(float2)\n"
"\n"
"inline float filter_temp_float(float cur_prefs3, float cur_prefs, float cur_mrefs, float cur_mrefs3,\n"
"                               float prev2_prefs4, float prev2_prefs2, float prev2_0, float prev2_mrefs2, float prev2_mrefs4,\n"
"                               float prev_prefs, float prev_mrefs, float next_prefs, float next_mrefs,\n"
"                               float next2_prefs4, float next2_prefs2, float next2_0, float next2_mrefs2, float next2_mrefs4)\n"
"{\n"
"    float final;\n"
"    float c = cur_mrefs;\n"
"    float d = (prev2_0 + next2_0) * 0.5f;\n"
"    float e = cur_prefs;\n"
"    float temporal_diff0 = fabs(prev2_0 - next2_0);\n"
"    float temporal_diff1 = (fabs(prev_mrefs - c) + fabs(prev_prefs - e)) * 0.5f;\n"
"    float temporal_diff2 = (fabs(next_mrefs - c) + fabs(next_prefs - e)) * 0.5f;\n"
"    float diff = max3(temporal_diff0 * 0.5f, temporal_diff1, temporal_diff2);\n"
"\n"
"    if (!diff) {\n"
"        final = d;\n"
"    } else {\n"
"        float b = ((prev2_mrefs2 + next2_mrefs2) * 0.5f) - c;\n"
"        float f = ((prev2_prefs2 + next2_prefs2) * 0.5f) - e;\n"
"        float dc = d - c;\n"
"        float de = d - e;\n"
"        float mmax = max3(de, dc, min(b, f));\n"
"        float mmin = min3(de, dc, max(b, f));\n"
"        diff = max3(diff, mmin, -mmax);\n"
"\n"
"        float interpol;\n"
"        if (fabs(c - e) > temporal_diff0) {\n"
"            interpol = native_divide((((coef_hf[0] * (prev2_0 + next2_0)\n"
"                - coef_hf[1] * (prev2_mrefs2 + next2_mrefs2 + prev2_prefs2 + next2_prefs2)\n"
"                + coef_hf[2] * (prev2_mrefs4 + next2_mrefs4 + prev2_prefs4 + next2_mrefs4)) * 0.25f)\n"
"                + coef_lf[0] * (c + e) - coef_lf[1] * (cur_mrefs3 + cur_prefs3)), (float)(1 << 13));\n"
"        } else {\n"
"            interpol = native_divide((coef_sp[0] * (c + e) - coef_sp[1] * (cur_mrefs3 + cur_prefs3)), (float)(1 << 13));\n"
"        }\n"
"\n"
"        if (interpol > d + diff) {\n"
"            interpol = d + diff;\n"
"        } else if (interpol < d - diff) {\n"
"            interpol = d - diff;\n"
"        }\n"
"        final = clamp(interpol, 0.0f, 1.0f);\n"
"    }\n"
"    return final;\n"
"}\n"
"\n"
"inline float2 filter_temp_float2(float2 cur_prefs3, float2 cur_prefs, float2 cur_mrefs, float2 cur_mrefs3,\n"
"                                 float2 prev2_prefs4, float2 prev2_prefs2, float2 prev2_0, float2 prev2_mrefs2, float2 prev2_mrefs4,\n"
"                                 float2 prev_prefs, float2 prev_mrefs, float2 next_prefs, float2 next_mrefs,\n"
"                                 float2 next2_prefs4, float2 next2_prefs2, float2 next2_0, float2 next2_mrefs2, float2 next2_mrefs4)\n"
"{\n"
"    return (float2)(filter_temp_float(cur_prefs3.x, cur_prefs.x, cur_mrefs.x, cur_mrefs3.x,\n"
"                                      prev2_prefs4.x, prev2_prefs2.x, prev2_0.x, prev2_mrefs2.x, prev2_mrefs4.x,\n"
"                                      prev_prefs.x, prev_mrefs.x, next_prefs.x, next_mrefs.x,\n"
"                                      next2_prefs4.x, next2_prefs2.x, next2_0.x, next2_mrefs2.x, next2_mrefs4.x),\n"
"                    filter_temp_float(cur_prefs3.y, cur_prefs.y, cur_mrefs.y, cur_mrefs3.y,\n"
"                                      prev2_prefs4.y, prev2_prefs2.y, prev2_0.y, prev2_mrefs2.y, prev2_mrefs4.y,\n"
"                                      prev_prefs.y, prev_mrefs.y, next_prefs.y, next_mrefs.y,\n"
"                                      next2_prefs4.y, next2_prefs2.y, next2_0.y, next2_mrefs2.y, next2_mrefs4.y));\n"
"}\n"
"\n"
"#define BWDIF_COMPUTE(T, XY) \\\n"
"inline T bwdif_compute_##T(__write_only image2d_t dst, \\\n"
"                           __read_only  image2d_t cur, \\\n"
"                           __read_only  image2d_t prev2, \\\n"
"                           __read_only  image2d_t prev1, \\\n"
"                           __read_only  image2d_t next1, \\\n"
"                           __read_only  image2d_t next2, \\\n"
"                           int parity, \\\n"
"                           bool is_field_end, \\\n"
"                           int2 pos) \\\n"
"{ \\\n"
"    /* Don't modify the primary field */ \\\n"
"    if (pos.y % 2 == parity) { \\\n"
"        return read_imagef(cur, sampler, (int2)(pos.x, pos.y)).XY; \\\n"
"    } \\\n"
"    T cur_prefs3 = read_imagef(cur, sampler, (int2)(pos.x, pos.y + 3)).XY; \\\n"
"    T cur_prefs  = read_imagef(cur, sampler, (int2)(pos.x, pos.y + 1)).XY; \\\n"
"    T cur_mrefs  = read_imagef(cur, sampler, (int2)(pos.x, pos.y - 1)).XY; \\\n"
"    T cur_mrefs3 = read_imagef(cur, sampler, (int2)(pos.x, pos.y - 3)).XY; \\\n"
"    if (is_field_end) { \\\n"
"        return filter_intra_##T(cur_prefs3, cur_prefs, cur_mrefs, cur_mrefs3); \\\n"
"    } \\\n"
"    /* Calculate temporal prediction */ \\\n"
"    T prev2_prefs4 = read_imagef(prev2, sampler, (int2)(pos.x, pos.y + 4)).XY; \\\n"
"    T prev2_prefs2 = read_imagef(prev2, sampler, (int2)(pos.x, pos.y + 2)).XY; \\\n"
"    T prev2_0      = read_imagef(prev2, sampler, (int2)(pos.x, pos.y + 0)).XY; \\\n"
"    T prev2_mrefs2 = read_imagef(prev2, sampler, (int2)(pos.x, pos.y - 2)).XY; \\\n"
"    T prev2_mrefs4 = read_imagef(prev2, sampler, (int2)(pos.x, pos.y - 4)).XY; \\\n"
"    T prev_prefs   = read_imagef(prev1, sampler, (int2)(pos.x, pos.y + 1)).XY; \\\n"
"    T prev_mrefs   = read_imagef(prev1, sampler, (int2)(pos.x, pos.y - 1)).XY; \\\n"
"    T next_prefs   = read_imagef(next1, sampler, (int2)(pos.x, pos.y + 1)).XY; \\\n"
"    T next_mrefs   = read_imagef(next1, sampler, (int2)(pos.x, pos.y - 1)).XY; \\\n"
"    T next2_prefs4 = read_imagef(next2, sampler, (int2)(pos.x, pos.y + 4)).XY; \\\n"
"    T next2_prefs2 = read_imagef(next2, sampler, (int2)(pos.x, pos.y + 2)).XY; \\\n"
"    T next2_0      = read_imagef(next2, sampler, (int2)(pos.x, pos.y + 0)).XY; \\\n"
"    T next2_mrefs2 = read_imagef(next2, sampler, (int2)(pos.x, pos.y - 2)).XY; \\\n"
"    T next2_mrefs4 = read_imagef(next2, sampler, (int2)(pos.x, pos.y - 4)).XY; \\\n"
"    return filter_temp_##T(cur_prefs3, cur_prefs, cur_mrefs, cur_mrefs3, \\\n"
"                           prev2_prefs4, prev2_prefs2, prev2_0, prev2_mrefs2, prev2_mrefs4, \\\n"
"                           prev_prefs, prev_mrefs, next_prefs, next_mrefs, \\\n"
"                           next2_prefs4, next2_prefs2, next2_0, next2_mrefs2, next2_mrefs4); \\\n"
"}\n"
"\n"
"BWDIF_COMPUTE(float, x)\n"
"BWDIF_COMPUTE(float2, xy)\n"
"\n"
"__kernel void bwdif(__write_only image2d_t dst,\n"
"                    __read_only  image2d_t prev,\n"
"                    __read_only  image2d_t cur,\n"
"                    __read_only  image2d_t next,\n"
"                    int channels,\n"
"                    int parity,\n"
"                    int is_field_end,\n"
"                    int is_second_field)\n"
"{\n"
"    int2 pos = (int2)(get_global_id(0), get_global_id(1));\n"
"\n"
"    if (pos.x >= get_image_width(dst) ||\n"
"        pos.y >= get_image_height(dst))\n"
"        return;\n"
"\n"
"    if (channels == 1) {\n"
"        float pred = is_second_field\n"
"            ? bwdif_compute_float(dst, cur, prev, cur, next, next,\n"
"                                  parity, is_field_end, pos)\n"
"            : bwdif_compute_float(dst, cur, prev, prev, cur, next,\n"
"                                  parity, is_field_end, pos);\n"
"\n"
"        write_imagef(dst, pos, (float4)(pred, 0.0f, 0.0f, 1.0f));\n"
"    } else if (channels == 2) {\n"
"        float2 pred = is_second_field\n"
"            ? bwdif_compute_float2(dst, cur, prev, cur, next, next,\n"
"                                   parity, is_field_end, pos)\n"
"            : bwdif_compute_float2(dst, cur, prev, prev, cur, next,\n"
"                                   parity, is_field_end, pos);\n"
"\n"
"        write_imagef(dst, pos, (float4)(pred.x, pred.y, 0.0f, 1.0f));\n"
"    }\n"
"}\n"
;
