// Generated from libavfilter/opencl/tonemap.cl
const char *ff_source_tonemap_cl =
"/*\n"
" * This file is part of FFmpeg.\n"
" *\n"
" * FFmpeg is free software; you can redistribute it and/or\n"
" * modify it under the terms of the GNU Lesser General Public\n"
" * License as published by the Free Software Foundation; either\n"
" * version 2.1 of the License, or (at your option) any later version.\n"
" *\n"
" * FFmpeg is distributed in the hope that it will be useful,\n"
" * but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU\n"
" * Lesser General Public License for more details.\n"
" *\n"
" * You should have received a copy of the GNU Lesser General Public\n"
" * License along with FFmpeg; if not, write to the Free Software\n"
" * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA\n"
" */\n"
"\n"
"#ifdef DOVI_RESHAPE\n"
"  #undef typedef_vecs\n"
"  #undef M_ZERO_VEC\n"
"  #define typedef_vecs(base, new) \\\n"
"    typedef base     new;    \\\n"
"    typedef base##2  new##2; \\\n"
"    typedef base##3  new##3; \\\n"
"    typedef base##4  new##4; \\\n"
"    typedef base##8  new##8; \\\n"
"    typedef base##16 new##16;\n"
"  #ifdef DOVI_PERF_FP16\n"
"    #pragma OPENCL EXTENSION cl_khr_fp16 : enable\n"
"    #define M_ZERO_VEC 0.0h\n"
"    typedef_vecs(half,  vec)\n"
"  #else\n"
"    #define M_ZERO_VEC 0.0f\n"
"    typedef_vecs(float, vec)\n"
"  #endif\n"
"  #undef typedef_vecs\n"
"#endif\n"
"\n"
"#define FLOAT_EPS 1e-6f\n"
"#define LUT_SIZE 65\n"
"\n"
"extern float3 lrgb2yuv(float3);\n"
"extern float  lrgb2y(float3);\n"
"extern float3 yuv2lrgb(float3);\n"
"extern float3 lrgb2lrgb(float3);\n"
"extern float  eotf_st2084(float);\n"
"extern float  inverse_eotf_st2084(float);\n"
"extern float4 get_luma_dst4(float4, float4, float4);\n"
"extern float3 get_chroma_sample(float3, float3, float3, float3);\n"
"#ifdef DOVI_RESHAPE\n"
"extern float3 rgb2lrgb(float3);\n"
"extern float3 ycc2rgb(float, float, float);\n"
"extern float3 lms2rgb(float, float, float);\n"
"#endif\n"
"extern float4 eotf_st2084x4(float4 x);\n"
"extern float4 inverse_eotf_st2084x4(float4 x);\n"
"#ifdef TONE_MODE_ITP\n"
"extern void lrgb2ictcp(float4 r4, float4 g4, float4 b4, float4* i4, float4* ct4, float4* cp4);\n"
"extern void ictcp2lrgb(float4 i4, float4 ct4, float4 cp4, float4* r4, float4* g4, float4* b4);\n"
"#endif\n"
"extern float3 gamut_compress(float3 rgb);\n"
"\n"
"#ifdef ENABLE_DITHER\n"
"float get_dithered_y(float y, float d) {\n"
"    return floor(y * dither_quantization + d + 0.5f / dither_size2) * 1.0f / dither_quantization;\n"
"}\n"
"#endif\n"
"\n"
"float hable_f(float in) {\n"
"    float a = 0.15f, b = 0.50f, c = 0.10f, d = 0.20f, e = 0.02f, f = 0.30f;\n"
"    return (in * (in * a + b * c) + d * e) / (in * (in * a + b) + d * f) - e / f;\n"
"}\n"
"\n"
"float direct(float s, float peak, float target_peak) {\n"
"    return s;\n"
"}\n"
"\n"
"float linear(float s, float peak, float target_peak) {\n"
"    return s * tone_param / peak;\n"
"}\n"
"\n"
"float gamma(float s, float peak, float target_peak) {\n"
"    float p = s > 0.05f ? s / peak : 0.05f / peak;\n"
"    float v = native_powr(p, 1.0f / tone_param);\n"
"    return s > 0.05f ? v : (s * v / 0.05f);\n"
"}\n"
"\n"
"float clip(float s, float peak, float target_peak) {\n"
"    return clamp(s * tone_param, 0.0f, 1.0f);\n"
"}\n"
"\n"
"float reinhard(float s, float peak, float target_peak) {\n"
"    return s / (s + tone_param) * (peak + tone_param) / peak;\n"
"}\n"
"\n"
"float hable(float s, float peak, float target_peak) {\n"
"    return hable_f(s) / hable_f(peak);\n"
"}\n"
"\n"
"float mobius(float s, float peak, float target_peak) {\n"
"    float j = tone_param;\n"
"    float a, b;\n"
"\n"
"    if (s <= j)\n"
"        return s;\n"
"\n"
"    a = -j * j * (peak - 1.0f) / (j * j - 2.0f * j + peak);\n"
"    b = (j * j - 2.0f * j * peak + peak) / fmax(peak - 1.0f, FLOAT_EPS);\n"
"\n"
"    return (b * b + 2.0f * b * j + j * j) / (b - a) * (s + a) / (s + b);\n"
"}\n"
"\n"
"float bt2390(float s, float peak_inv_pq, float target_peak_inv_pq) {\n"
"    float peak_pq = peak_inv_pq;\n"
"    float scale = peak_pq > 0.0f ? (1.0f / peak_pq) : 1.0f;\n"
"\n"
"    float s_pq = s * scale;\n"
"    float max_lum = target_peak_inv_pq * scale;\n"
"\n"
"    float ks = (1.0f + tone_param) * max_lum - tone_param;\n"
"    float tb = (s_pq - ks) / (1.0f - ks);\n"
"    float tb2 = tb * tb;\n"
"    float tb3 = tb2 * tb;\n"
"    float pb = (2.0f * tb3 - 3.0f * tb2 + 1.0f) * ks +\n"
"               (tb3 - 2.0f * tb2 + tb) * (1.0f - ks) +\n"
"               (-2.0f * tb3 + 3.0f * tb2) * max_lum;\n"
"    float sig = mix(pb, s_pq, s_pq < ks);\n"
"\n"
"    return sig * peak_pq;\n"
"}\n"
"\n"
"#define MAP_FOUR_PIXELS(sig, peak, target_peak) \\\n"
"{ \\\n"
"    sig.x = TONE_FUNC(sig.x, peak, target_peak); \\\n"
"    sig.y = TONE_FUNC(sig.y, peak, target_peak); \\\n"
"    sig.z = TONE_FUNC(sig.z, peak, target_peak); \\\n"
"    sig.w = TONE_FUNC(sig.w, peak, target_peak); \\\n"
"}\n"
"\n"
"#ifndef TONE_MODE_ITP\n"
"void map_four_pixels_rgb(float4 *r4, float4 *g4, float4 *b4, float peak) {\n"
"#ifdef TONE_MODE_RGB\n"
"    float4 sig_r = fmax(*r4, FLOAT_EPS), sig_ro = sig_r;\n"
"    float4 sig_g = fmax(*g4, FLOAT_EPS), sig_go = sig_g;\n"
"    float4 sig_b = fmax(*b4, FLOAT_EPS), sig_bo = sig_b;\n"
"#else\n"
"  #ifdef TONE_MODE_MAX\n"
"    float4 sig = fmax(fmax(*r4, fmax(*g4, *b4)), FLOAT_EPS);\n"
"  #else\n"
"    float4 sig = fmax((*r4 * 0.2627f + *g4 * 0.678f + *b4 * 0.0593f), FLOAT_EPS);\n"
"  #endif\n"
"    float4 sig_o = sig;\n"
"#endif\n"
"\n"
"    // Desaturate the color using a coefficient dependent on the signal level\n"
"    if (desat_param > 0.0f) {\n"
"#ifdef TONE_MODE_RGB\n"
"        float4 sig = fmax(fmax(*r4, fmax(*g4, *b4)), FLOAT_EPS);\n"
"#endif\n"
"#ifdef MAP_IN_DST_SPACE\n"
"        float4 luma = get_luma_dst4(*r4, *g4, *b4);\n"
"#else // only LUM mode currently\n"
"        float4 luma = sig;\n"
"#endif\n"
"        float4 coeff = fmax(sig - 0.18f, FLOAT_EPS) / fmax(sig, FLOAT_EPS);\n"
"        coeff = native_powr(coeff, 10.0f / desat_param);\n"
"        *r4 = mix(*r4, luma, coeff);\n"
"        *g4 = mix(*g4, luma, coeff);\n"
"        *b4 = mix(*b4, luma, coeff);\n"
"    }\n"
"\n"
"#ifdef TONE_FUNC_BT2390\n"
"    float src_peak_delin_pq = inverse_eotf_st2084(peak);\n"
"    float dst_peak_delin_pq = inverse_eotf_st2084(target_peak);\n"
"  #ifdef TONE_MODE_RGB\n"
"    sig_r = inverse_eotf_st2084x4(fmin(sig_r, peak));\n"
"    sig_g = inverse_eotf_st2084x4(fmin(sig_g, peak));\n"
"    sig_b = inverse_eotf_st2084x4(fmin(sig_b, peak));\n"
"    MAP_FOUR_PIXELS(sig_r, src_peak_delin_pq, dst_peak_delin_pq)\n"
"    MAP_FOUR_PIXELS(sig_g, src_peak_delin_pq, dst_peak_delin_pq)\n"
"    MAP_FOUR_PIXELS(sig_b, src_peak_delin_pq, dst_peak_delin_pq)\n"
"    sig_r = eotf_st2084x4(sig_r);\n"
"    sig_g = eotf_st2084x4(sig_g);\n"
"    sig_b = eotf_st2084x4(sig_b);\n"
"  #else\n"
"    sig = inverse_eotf_st2084x4(fmin(sig, peak));\n"
"    MAP_FOUR_PIXELS(sig, src_peak_delin_pq, dst_peak_delin_pq)\n"
"    sig = eotf_st2084x4(sig);\n"
"  #endif\n"
"#else\n"
"  #ifdef TONE_MODE_RGB\n"
"    MAP_FOUR_PIXELS(sig_r, peak, target_peak)\n"
"    MAP_FOUR_PIXELS(sig_g, peak, target_peak)\n"
"    MAP_FOUR_PIXELS(sig_b, peak, target_peak)\n"
"  #else\n"
"    MAP_FOUR_PIXELS(sig, peak, target_peak)\n"
"  #endif\n"
"#endif\n"
"\n"
"#ifdef TONE_MODE_RGB\n"
"    sig_r = fmin(sig_r, 1.0f);\n"
"    sig_g = fmin(sig_g, 1.0f);\n"
"    sig_b = fmin(sig_b, 1.0f);\n"
"    float4 factor_r = sig_r / sig_ro;\n"
"    float4 factor_g = sig_g / sig_go;\n"
"    float4 factor_b = sig_b / sig_bo;\n"
"    *r4 *= factor_r;\n"
"    *g4 *= factor_g;\n"
"    *b4 *= factor_b;\n"
"#else\n"
"    sig = fmin(sig, 1.0f);\n"
"    float4 factor = sig / sig_o;\n"
"    *r4 *= factor;\n"
"    *g4 *= factor;\n"
"    *b4 *= factor;\n"
"#endif\n"
"}\n"
"#endif\n"
"\n"
"#ifdef TONE_MODE_ITP\n"
"void map_four_pixels_itp(float4 *r4, float4 *g4, float4 *b4, float peak) {\n"
"    float4 i4_o, i4, ct4 , cp4;\n"
"#ifdef TONE_FUNC_BT2390\n"
"    *r4 = fmin(*r4, peak);\n"
"    *g4 = fmin(*g4, peak);\n"
"    *b4 = fmin(*b4, peak);\n"
"#endif\n"
"    lrgb2ictcp(*r4, *g4, *b4, &i4, &ct4, &cp4);\n"
"    i4 = fmax(i4, FLOAT_EPS);\n"
"    i4_o = i4;\n"
"    if (desat_param > 0.0f) {\n"
"        float4 coeff = native_exp(-pow(eotf_st2084x4(i4) - (target_peak - desat_param) * 0.5f, 2) / (2.0f * peak));\n"
"        ct4 *= coeff;\n"
"        cp4 *= coeff;\n"
"    }\n"
"#ifdef TONE_FUNC_BT2390\n"
"    float src_peak_delin_pq = inverse_eotf_st2084(peak);\n"
"    float dst_peak_delin_pq = inverse_eotf_st2084(target_peak);\n"
"    MAP_FOUR_PIXELS(i4, src_peak_delin_pq, dst_peak_delin_pq)\n"
"#else\n"
"    i4 = eotf_st2084x4(i4);\n"
"    MAP_FOUR_PIXELS(i4, peak, target_peak)\n"
"    i4 = inverse_eotf_st2084x4(i4);\n"
"#endif\n"
"    i4 = fmin(i4, 1.0f);\n"
"    float4 factor = min(i4/i4_o, i4_o/i4);\n"
"    ct4 *= factor;\n"
"    cp4 *= factor;\n"
"    ictcp2lrgb(i4, ct4, cp4, r4, g4, b4);\n"
"}\n"
"#endif\n"
"\n"
"// Map from source space YUV to source space RGB\n"
"float3 map_to_src_space_from_yuv(float3 yuv) {\n"
"#ifdef DOVI_RESHAPE\n"
"    float3 c = ycc2rgb(yuv.x, yuv.y, yuv.z);\n"
"    c = lms2rgb(c.x, c.y, c.z);\n"
"    c = rgb2lrgb(c);\n"
"#else\n"
"    float3 c = yuv2lrgb(yuv);\n"
"#endif\n"
"    return c;\n"
"}\n"
"\n"
"// Map from source space YUV to destination space RGB\n"
"float3 map_to_dst_space_from_yuv(float3 yuv) {\n"
"#ifdef DOVI_RESHAPE\n"
"    float3 c = ycc2rgb(yuv.x, yuv.y, yuv.z);\n"
"    c = lms2rgb(c.x, c.y, c.z);\n"
"    c = rgb2lrgb(c);\n"
"    c = lrgb2lrgb(c);\n"
"#else\n"
"    float3 c = yuv2lrgb(yuv);\n"
"    c = lrgb2lrgb(c);\n"
"#endif\n"
"    return c;\n"
"}\n"
"\n"
"#ifdef DOVI_RESHAPE\n"
"vec reshape_mmr(vec3 sig,\n"
"                vec4 coeffs,\n"
"                __global const vec4 *dovi_mmr,\n"
"                uchar dovi_mmr_single,\n"
"                uchar dovi_min_order,\n"
"                uchar dovi_max_order)\n"
"{\n"
"    uchar mmr_idx = dovi_mmr_single ? 0 : (uchar)coeffs.y;\n"
"    uchar order = (uchar)coeffs.w;\n"
"    vec4 sigX;\n"
"    bool t;\n"
"\n"
"    vec s = coeffs.x;\n"
"    sigX.xyz = sig.xxy * sig.yzz;\n"
"    sigX.w = sigX.x * sig.z;\n"
"    s += dot(dovi_mmr[mmr_idx + 0].xyz, sig);\n"
"    s += dot(dovi_mmr[mmr_idx + 1], sigX);\n"
"\n"
"    // Branching here is faster from testing, divergence rate for I channel seems to be low\n"
"    t = dovi_max_order >= 2 && (dovi_min_order >= 2 || order >= 2);\n"
"    if (t) {\n"
"        vec3 sig2 = sig * sig;\n"
"        vec4 sigX2 = sigX * sigX;\n"
"        s += dot(dovi_mmr[mmr_idx + 2].xyz, sig2);\n"
"        s += dot(dovi_mmr[mmr_idx + 3], sigX2);\n"
"        t = dovi_max_order == 3 && (dovi_min_order == 3 || order >= 3);\n"
"        if (t) {\n"
"            s += dot(dovi_mmr[mmr_idx + 4].xyz, sig2 * sig);\n"
"            s += dot(dovi_mmr[mmr_idx + 5], sigX2 * sigX);\n"
"        }\n"
"    }\n"
"\n"
"    return s;\n"
"}\n"
"\n"
"#ifndef IS_QCOM_GPU\n"
"vec4 reshape_polyx4(vec4 s, vec4 coeffsx, vec4 coeffsy, vec4 coeffsz) {\n"
"    return mad(mad(coeffsz, s, coeffsy), s, coeffsx);\n"
"}\n"
"\n"
"vec4 reshape_mmrx4(vec4 sig_i4,\n"
"                   vec4 sig_p4,\n"
"                   vec4 sig_t4,\n"
"                   vec4 coeffsx,\n"
"                   vec4 coeffsy,\n"
"                   vec4 coeffsz,\n"
"                   vec4 coeffsw,\n"
"                   __global const vec4 *dovi_mmr,\n"
"                   uchar dovi_mmr_single,\n"
"                   uchar dovi_min_order,\n"
"                   uchar dovi_max_order)\n"
"{\n"
"    vec4 coeffs = (vec4)(coeffsx.x, coeffsy.x, coeffsz.x, coeffsw.x);\n"
"    vec4 result;\n"
"    result.x = reshape_mmr((vec3)(sig_i4.x, sig_p4.x, sig_t4.x), coeffs, dovi_mmr,\n"
"                           dovi_mmr_single, dovi_min_order, dovi_max_order);\n"
"    coeffs = (vec4)(coeffsx.y, coeffsy.y, coeffsz.y, coeffsw.y);\n"
"    result.y = reshape_mmr((vec3)(sig_i4.y, sig_p4.y, sig_t4.y), coeffs, dovi_mmr,\n"
"                           dovi_mmr_single, dovi_min_order, dovi_max_order);\n"
"    coeffs = (vec4)(coeffsx.z, coeffsy.z, coeffsz.z, coeffsw.z);\n"
"    result.z = reshape_mmr((vec3)(sig_i4.z, sig_p4.z, sig_t4.z), coeffs, dovi_mmr,\n"
"                           dovi_mmr_single, dovi_min_order, dovi_max_order);\n"
"    coeffs = (vec4)(coeffsx.w, coeffsy.w, coeffsz.w, coeffsw.w);\n"
"    result.w = reshape_mmr((vec3)(sig_i4.w, sig_p4.w, sig_t4.w), coeffs, dovi_mmr,\n"
"                           dovi_mmr_single, dovi_min_order, dovi_max_order);\n"
"    return result;\n"
"}\n"
"\n"
"vec4 reshape_mmr_ptx4(vec4 sig_i4,\n"
"                      vec4 sig_p4,\n"
"                      vec4 sig_t4,\n"
"                      vec4 coeffs,\n"
"                      __global const vec4 *dovi_mmr,\n"
"                      uchar dovi_mmr_single,\n"
"                      uchar dovi_min_order,\n"
"                      uchar dovi_max_order)\n"
"{\n"
"    uchar mmr_idx = dovi_mmr_single ? 0 : (uchar)coeffs.y;\n"
"  #ifdef DOVI_PERF_FP16\n"
"    const vec8 mmr_order1 = vload8(0, (__global const vec *)&dovi_mmr[mmr_idx]);\n"
"  #else\n"
"    const vec8 mmr_order1 = (vec8)(dovi_mmr[mmr_idx + 0], dovi_mmr[mmr_idx + 1]);\n"
"  #endif\n"
"    uchar order = (uchar)coeffs.w;\n"
"    bool t;\n"
"    vec4 sigXx, sigXy, sigXz, sigXw;\n"
"    vec4 sx4 = (vec4)coeffs.x;\n"
"    sigXx = sig_i4 * sig_p4;\n"
"    sigXy = sig_i4 * sig_t4;\n"
"    sigXz = sig_p4 * sig_t4;\n"
"    sigXw = sigXx * sig_t4;\n"
"\n"
"  #define DOT_MMR(A, B, C, D, E, F, G, ORD)  \\\n"
"    sx4 = mad((A), (vec4)(ORD.lo.x), sx4);   \\\n"
"    sx4 = mad((B), (vec4)(ORD.lo.y), sx4);   \\\n"
"    sx4 = mad((C), (vec4)(ORD.lo.z), sx4);   \\\n"
"    sx4 = mad((D), (vec4)(ORD.hi.x), sx4);   \\\n"
"    sx4 = mad((E), (vec4)(ORD.hi.y), sx4);   \\\n"
"    sx4 = mad((F), (vec4)(ORD.hi.z), sx4);   \\\n"
"    sx4 = mad((G), (vec4)(ORD.hi.w), sx4);   \\\n"
"\n"
"    DOT_MMR(sig_i4, sig_p4, sig_t4, sigXx, sigXy, sigXz, sigXw, mmr_order1)\n"
"\n"
"    // Branching is free for PT channels as the condition t is same for all threads.\n"
"    t = dovi_max_order >= 2 && (dovi_min_order >= 2 || order >= 2);\n"
"    if (t) {\n"
"  #ifdef DOVI_PERF_FP16\n"
"        const vec8 mmr_order2 = vload8(1, (__global const vec *)&dovi_mmr[mmr_idx]);\n"
"  #else\n"
"        const vec8 mmr_order2 = (vec8)(dovi_mmr[mmr_idx + 2], dovi_mmr[mmr_idx + 3]);\n"
"  #endif\n"
"        vec4 sig2_i4 = sig_i4 * sig_i4;\n"
"        vec4 sig2_p4 = sig_p4 * sig_p4;\n"
"        vec4 sig2_t4 = sig_t4 * sig_t4;\n"
"        vec4 sigX2x = sigXx * sigXx;\n"
"        vec4 sigX2y = sigXy * sigXy;\n"
"        vec4 sigX2z = sigXz * sigXz;\n"
"        vec4 sigX2w = sigXw * sigXw;\n"
"\n"
"        DOT_MMR(sig2_i4, sig2_p4, sig2_t4, sigX2x, sigX2y, sigX2z, sigX2w, mmr_order2);\n"
"\n"
"        t = dovi_max_order == 3 && (dovi_min_order == 3 || order >= 3);\n"
"        if (t) {\n"
"  #ifdef DOVI_PERF_FP16\n"
"            const vec8 mmr_order3 = vload8(2, (__global const vec *)&dovi_mmr[mmr_idx]);\n"
"  #else\n"
"            const vec8 mmr_order3 = (vec8)(dovi_mmr[mmr_idx + 4], dovi_mmr[mmr_idx + 5]);\n"
"  #endif\n"
"            DOT_MMR(sig2_i4 * sig_i4, sig2_p4 * sig_p4, sig2_t4 * sig_t4,\n"
"                    sigX2x * sigXx, sigX2y * sigXy, sigX2z * sigXz, sigX2w * sigXw,\n"
"                    mmr_order3);\n"
"        }\n"
"    }\n"
"\n"
"    return sx4;\n"
"  #undef DOT_MMR\n"
"}\n"
"\n"
"void reshape_dovi_iptx4(float3 *ipt0,\n"
"                        float3 *ipt1,\n"
"                        float3 *ipt2,\n"
"                        float3 *ipt3,\n"
"                        __global const vec *src_dovi_params,\n"
"                        __global const vec *src_dovi_pivots,\n"
"                        __global const vec4 *src_dovi_coeffs,\n"
"                        __global const vec4 *src_dovi_mmr)\n"
"{\n"
"    bool has_mmr_poly, t;\n"
"    vec4 do_poly, coeffw_is_zero;\n"
"    vec4 coeffs, coeffsx, coeffsy, coeffsz, coeffsw, sx4;\n"
"    float4 result;\n"
"    uchar dovi_num_pivots, dovi_has_mmr, dovi_has_poly;\n"
"    uchar dovi_mmr_single, dovi_min_order, dovi_max_order;\n"
"    vec dovi_lo, dovi_hi;\n"
"    __global const vec *dovi_params;\n"
"    __global const vec *dovi_pivots;\n"
"    __global const vec4 *dovi_coeffs, *dovi_mmr;\n"
"\n"
"  #ifdef DOVI_PERF_FP16\n"
"    vec4 sig_i4 = convert_half4(clamp((vec4)((*ipt0).x,(*ipt1).x,(*ipt2).x,(*ipt3).x), 0.0f, 1.0f));\n"
"    vec4 sig_p4 = convert_half4(clamp((vec4)((*ipt0).y,(*ipt1).y,(*ipt2).y,(*ipt3).y), 0.0f, 1.0f));\n"
"    vec4 sig_t4 = convert_half4(clamp((vec4)((*ipt0).z,(*ipt1).z,(*ipt2).z,(*ipt3).z), 0.0f, 1.0f));\n"
"  #else\n"
"    vec4 sig_i4 = clamp((vec4)((*ipt0).x,(*ipt1).x,(*ipt2).x,(*ipt3).x), 0.0f, 1.0f);\n"
"    vec4 sig_p4 = clamp((vec4)((*ipt0).y,(*ipt1).y,(*ipt2).y,(*ipt3).y), 0.0f, 1.0f);\n"
"    vec4 sig_t4 = clamp((vec4)((*ipt0).z,(*ipt1).z,(*ipt2).z,(*ipt3).z), 0.0f, 1.0f);\n"
"  #endif\n"
"\n"
"  #define SETUP_DOVI_PARAMS(channel_offset) \\\n"
"    dovi_params = src_dovi_params + (channel_offset)*8; \\\n"
"    dovi_pivots = src_dovi_pivots + (channel_offset)*8; \\\n"
"    dovi_coeffs = src_dovi_coeffs + (channel_offset)*8; \\\n"
"    dovi_mmr = src_dovi_mmr + (channel_offset)*48;      \\\n"
"    dovi_num_pivots = dovi_params[0];                   \\\n"
"    dovi_has_mmr = dovi_params[1];                      \\\n"
"    dovi_has_poly = dovi_params[2];                     \\\n"
"    dovi_mmr_single = dovi_params[3];                   \\\n"
"    dovi_min_order = dovi_params[4];                    \\\n"
"    dovi_max_order = dovi_params[5];                    \\\n"
"    dovi_lo = dovi_params[6];                           \\\n"
"    dovi_hi = dovi_params[7];\n"
"\n"
"  #define EXTRACT_COEFFS() \\\n"
"    coeffs = dovi_coeffs[0];  \\\n"
"    coeffsx = (vec4)coeffs.x; \\\n"
"    coeffsy = (vec4)coeffs.y; \\\n"
"    coeffsz = (vec4)coeffs.z; \\\n"
"    coeffsw = (vec4)coeffs.w;\n"
"\n"
"    // Reshape I\n"
"    SETUP_DOVI_PARAMS(0)\n"
"    EXTRACT_COEFFS()\n"
"\n"
"    if (dovi_num_pivots > 2) {\n"
"  #ifdef DOVI_PERF_FP16\n"
"        const vec8 pivots0 = vload8(0, (__global const vec *)dovi_pivots);\n"
"        const vec8 coeffs0 = vload8(0, (__global const vec *)dovi_coeffs);\n"
"        const vec8 coeffs1 = vload8(1, (__global const vec *)dovi_coeffs);\n"
"        const vec8 coeffs2 = vload8(2, (__global const vec *)dovi_coeffs);\n"
"        const vec8 coeffs3 = vload8(3, (__global const vec *)dovi_coeffs);\n"
"\n"
"        const vec *pivots = (const vec *)&pivots0;\n"
"  #else\n"
"        __global const vec *pivots = dovi_pivots;\n"
"        const vec8 coeffs0 = (vec8)(dovi_coeffs[0], dovi_coeffs[1]);\n"
"        const vec8 coeffs1 = (vec8)(dovi_coeffs[2], dovi_coeffs[3]);\n"
"        const vec8 coeffs2 = (vec8)(dovi_coeffs[4], dovi_coeffs[5]);\n"
"        const vec8 coeffs3 = (vec8)(dovi_coeffs[6], dovi_coeffs[7]);\n"
"  #endif\n"
"\n"
"  #define PICK_COEFF_FOR(LANE) \\\n"
"        mix(                                                          \\\n"
"          mix(                                                        \\\n"
"            mix(coeffs0.lo, coeffs0.hi, (vec4)((LANE) >= pivots[0])), \\\n"
"            mix(coeffs1.lo, coeffs1.hi, (vec4)((LANE) >= pivots[2])), \\\n"
"            (vec4)((LANE) >= pivots[1])                               \\\n"
"          ),                                                          \\\n"
"          mix(                                                        \\\n"
"            mix(coeffs2.lo, coeffs2.hi, (vec4)((LANE) >= pivots[4])), \\\n"
"            mix(coeffs3.lo, coeffs3.hi, (vec4)((LANE) >= pivots[6])), \\\n"
"            (vec4)((LANE) >= pivots[5])                               \\\n"
"          ),                                                          \\\n"
"          (vec4)((LANE) >= pivots[3])                                 \\\n"
"        )\n"
"\n"
"  #define PACK_COEFFS(LANE) \\\n"
"        coeffsx.LANE = coeffs_temp.x; \\\n"
"        coeffsy.LANE = coeffs_temp.y; \\\n"
"        coeffsz.LANE = coeffs_temp.z; \\\n"
"        coeffsw.LANE = coeffs_temp.w;\n"
"\n"
"        vec4 coeffs_temp = PICK_COEFF_FOR(sig_i4.x);\n"
"        PACK_COEFFS(x)\n"
"\n"
"        coeffs_temp = PICK_COEFF_FOR(sig_i4.y);\n"
"        PACK_COEFFS(y)\n"
"\n"
"        coeffs_temp = PICK_COEFF_FOR(sig_i4.z);\n"
"        PACK_COEFFS(z)\n"
"\n"
"        coeffs_temp = PICK_COEFF_FOR(sig_i4.w);\n"
"        PACK_COEFFS(w)\n"
"\n"
"  #undef PICK_COEFF_FOR\n"
"  #undef PACK_COEFFS\n"
"    }\n"
"\n"
"    has_mmr_poly = dovi_has_mmr && dovi_has_poly;\n"
"  #ifdef DOVI_PERF_FP16\n"
"    coeffw_is_zero = convert_half4(coeffsw == (vec4)M_ZERO_VEC);\n"
"  #else\n"
"    coeffw_is_zero = convert_float4(coeffsw == (vec4)M_ZERO_VEC);\n"
"  #endif\n"
"    do_poly = has_mmr_poly\n"
"              ? coeffw_is_zero\n"
"              : (vec4)(dovi_has_poly != M_ZERO_VEC);\n"
"\n"
"    sx4 = mix(reshape_mmrx4(sig_i4, sig_p4, sig_t4,\n"
"                            coeffsx, coeffsy, coeffsz, coeffsw, dovi_mmr,\n"
"                            dovi_mmr_single, dovi_min_order, dovi_max_order),\n"
"              reshape_polyx4(sig_i4, coeffsx, coeffsy, coeffsz),\n"
"              do_poly);\n"
"  #ifdef DOVI_PERF_FP16\n"
"    result = convert_float4(clamp(sx4, dovi_lo, dovi_hi));\n"
"  #else\n"
"    result = clamp(sx4, dovi_lo, dovi_hi);\n"
"  #endif\n"
"\n"
"  #define STORE_RESULTS(LANE) \\\n"
"    (*ipt0).LANE = result.x; \\\n"
"    (*ipt1).LANE = result.y; \\\n"
"    (*ipt2).LANE = result.z; \\\n"
"    (*ipt3).LANE = result.w;\n"
"\n"
"    STORE_RESULTS(x)\n"
"\n"
"    // Reshape P\n"
"    SETUP_DOVI_PARAMS(1)\n"
"    EXTRACT_COEFFS()\n"
"\n"
"  #define RESHAPE_P_T(sig_x4) \\\n"
"    has_mmr_poly = dovi_has_mmr && dovi_has_poly;                               \\\n"
"    t = has_mmr_poly ? coeffs.w == M_ZERO_VEC : dovi_has_poly != M_ZERO_VEC;    \\\n"
"    sx4 = t ? reshape_polyx4(sig_x4, coeffsx, coeffsy, coeffsz)                 \\\n"
"            : reshape_mmr_ptx4(sig_i4, sig_p4, sig_t4,                          \\\n"
"                               coeffs, dovi_mmr,                                \\\n"
"                               dovi_mmr_single, dovi_min_order, dovi_max_order);\n"
"\n"
"    RESHAPE_P_T(sig_p4)\n"
"  #ifdef DOVI_PERF_FP16\n"
"    result = convert_float4(clamp(sx4, dovi_lo, dovi_hi));\n"
"  #else\n"
"    result = clamp(sx4, dovi_lo, dovi_hi);\n"
"  #endif\n"
"    STORE_RESULTS(y)\n"
"\n"
"    // Reshape T\n"
"    SETUP_DOVI_PARAMS(2)\n"
"    EXTRACT_COEFFS()\n"
"\n"
"    RESHAPE_P_T(sig_t4)\n"
"  #ifdef DOVI_PERF_FP16\n"
"    result = convert_float4(clamp(sx4, dovi_lo, dovi_hi));\n"
"  #else\n"
"    result = clamp(sx4, dovi_lo, dovi_hi);\n"
"  #endif\n"
"    STORE_RESULTS(z)\n"
"\n"
"  #undef RESHAPE_P_T\n"
"  #undef STORE_RESULTS\n"
"  #undef SETUP_DOVI_PARAMS\n"
"  #undef EXTRACT_COEFFS\n"
"}\n"
"#endif //#ifndef IS_QCOM_GPU\n"
"\n"
"// Qualcomm has a really bad OpenCL compiler that is having performance regression with vectorized reshaping kernel\n"
"// Make a scalar version just for them\n"
"#ifdef IS_QCOM_GPU\n"
"inline vec reshape_poly(vec s, vec4 coeffs) {\n"
"    return (coeffs.z * s + coeffs.y) * s + coeffs.x;\n"
"}\n"
"\n"
"inline void reshape_dovi_sig(float *dst,\n"
"                             const vec src,\n"
"                             const vec3 *sig,\n"
"                             const uchar idx,\n"
"                             __global const vec *src_dovi_params,\n"
"                             __global const vec *src_dovi_pivots,\n"
"                             __global const vec4 *src_dovi_coeffs,\n"
"                             __global const vec4 *src_dovi_mmr)\n"
"{\n"
"    bool t, has_mmr_poly;\n"
"    vec s = src;\n"
"    vec4 coeffs;\n"
"    uchar dovi_num_pivots, dovi_has_mmr, dovi_has_poly;\n"
"    uchar dovi_mmr_single, dovi_min_order, dovi_max_order;\n"
"    vec dovi_lo, dovi_hi;\n"
"    __global const vec *dovi_params;\n"
"    __global const vec *dovi_pivots;\n"
"    __global const vec4 *dovi_coeffs, *dovi_mmr;\n"
"\n"
"    dovi_params = src_dovi_params + (idx<<3);\n"
"    dovi_pivots = src_dovi_pivots + (idx<<3);\n"
"    dovi_coeffs = src_dovi_coeffs + (idx<<3);\n"
"    dovi_mmr = src_dovi_mmr + idx*48;\n"
"    dovi_num_pivots = dovi_params[0];\n"
"    dovi_has_mmr = dovi_params[1];\n"
"    dovi_has_poly = dovi_params[2];\n"
"    dovi_mmr_single = dovi_params[3];\n"
"    dovi_min_order = dovi_params[4];\n"
"    dovi_max_order = dovi_params[5];\n"
"    dovi_lo = dovi_params[6];\n"
"    dovi_hi = dovi_params[7];\n"
"\n"
"    coeffs = dovi_coeffs[0];\n"
"\n"
"    if (idx == 0 && dovi_num_pivots > 2) {\n"
"  #ifdef DOVI_PERF_FP16\n"
"        const vec8 pivots0 = vload8(0, (__global const vec *)dovi_pivots);\n"
"        const vec8 coeffs0 = vload8(0, (__global const vec *)dovi_coeffs);\n"
"        const vec8 coeffs1 = vload8(1, (__global const vec *)dovi_coeffs);\n"
"        const vec8 coeffs2 = vload8(2, (__global const vec *)dovi_coeffs);\n"
"        const vec8 coeffs3 = vload8(3, (__global const vec *)dovi_coeffs);\n"
"\n"
"        const vec *pivots = (const vec *)&pivots0;\n"
"  #else\n"
"        __global const vec *pivots = dovi_pivots;\n"
"        const vec8 coeffs0 = (vec8)(dovi_coeffs[0], dovi_coeffs[1]);\n"
"        const vec8 coeffs1 = (vec8)(dovi_coeffs[2], dovi_coeffs[3]);\n"
"        const vec8 coeffs2 = (vec8)(dovi_coeffs[4], dovi_coeffs[5]);\n"
"        const vec8 coeffs3 = (vec8)(dovi_coeffs[6], dovi_coeffs[7]);\n"
"  #endif\n"
"        coeffs = mix(mix(mix(coeffs0.lo, coeffs0.hi, (vec4)(s >= pivots[0])),\n"
"                         mix(coeffs1.lo, coeffs1.hi, (vec4)(s >= pivots[2])),\n"
"                         (vec4)(s >= pivots[1])),\n"
"                     mix(mix(coeffs2.lo, coeffs2.hi, (vec4)(s >= pivots[4])),\n"
"                         mix(coeffs3.lo, coeffs3.hi, (vec4)(s >= pivots[6])),\n"
"                         (vec4)(s >= pivots[5])),\n"
"                     (vec4)(s >= pivots[3]));\n"
"    }\n"
"\n"
"    has_mmr_poly = dovi_has_mmr && dovi_has_poly;\n"
"    t = (has_mmr_poly && coeffs.w == M_ZERO_VEC) || (!has_mmr_poly && dovi_has_poly);\n"
"\n"
"    s = t ? reshape_poly(s, coeffs)\n"
"          : reshape_mmr(*sig, coeffs, dovi_mmr,\n"
"                        dovi_mmr_single, dovi_min_order, dovi_max_order);\n"
"  #ifdef DOVI_PERF_FP16\n"
"    *dst = convert_float(clamp(s, dovi_lo, dovi_hi));\n"
"  #else\n"
"    *dst = clamp(s, dovi_lo, dovi_hi);\n"
"  #endif\n"
"}\n"
"\n"
"void reshape_dovi_ipt(float3 *ipt,\n"
"                      __global const vec *src_dovi_params,\n"
"                      __global const vec *src_dovi_pivots,\n"
"                      __global const vec4 *src_dovi_coeffs,\n"
"                      __global const vec4 *src_dovi_mmr)\n"
"{\n"
"  #ifdef DOVI_PERF_FP16\n"
"    const vec3 sig = convert_half3(clamp(*ipt, 0.0f, 1.0f));\n"
"  #else\n"
"    const vec3 sig = clamp(*ipt, 0.0f, 1.0f);\n"
"  #endif\n"
"    float dsti, dstp, dstt;\n"
"    reshape_dovi_sig(&dsti, sig.x, &sig, 0, src_dovi_params, src_dovi_pivots, src_dovi_coeffs, src_dovi_mmr);\n"
"    reshape_dovi_sig(&dstp, sig.y, &sig, 1, src_dovi_params, src_dovi_pivots, src_dovi_coeffs, src_dovi_mmr);\n"
"    reshape_dovi_sig(&dstt, sig.z, &sig, 2, src_dovi_params, src_dovi_pivots, src_dovi_coeffs, src_dovi_mmr);\n"
"    *ipt = (float3)(dsti, dstp, dstt);\n"
"}\n"
"#endif //#ifdef IS_QCOM_GPU\n"
"#endif //#ifdef DOVI_RESHAPE\n"
"\n"
"__constant sampler_t sampler = (CLK_NORMALIZED_COORDS_FALSE |\n"
"                                CLK_ADDRESS_CLAMP_TO_EDGE   |\n"
"                                CLK_FILTER_NEAREST);\n"
"\n"
"__constant sampler_t l_sampler = (CLK_NORMALIZED_COORDS_TRUE |\n"
"                                  CLK_ADDRESS_CLAMP_TO_EDGE  |\n"
"                                  CLK_FILTER_LINEAR);\n"
"\n"
"__constant sampler_t d_sampler = (CLK_NORMALIZED_COORDS_TRUE |\n"
"                                  CLK_ADDRESS_REPEAT         |\n"
"                                  CLK_FILTER_NEAREST);\n"
"\n"
"__kernel void tonemap(__write_only image2d_t dst1,\n"
"                      __read_only  image2d_t src1,\n"
"                      __write_only image2d_t dst2,\n"
"                      __read_only  image2d_t src2,\n"
"#ifdef NON_SEMI_PLANAR_OUT\n"
"                      __write_only image2d_t dst3,\n"
"#endif\n"
"#ifdef NON_SEMI_PLANAR_IN\n"
"                      __read_only  image2d_t src3,\n"
"#endif\n"
"#ifdef ENABLE_DITHER\n"
"                      __read_only  image2d_t dither,\n"
"#endif\n"
"#ifdef DOVI_RESHAPE\n"
"                      __global const vec *dovi_buf,\n"
"#endif\n"
"                      float peak)\n"
"{\n"
"    int xi = get_global_id(0);\n"
"    int yi = get_global_id(1);\n"
"    // each work item process four pixels\n"
"    int x = xi << 1;\n"
"    int y = yi << 1;\n"
"\n"
"    int2 src1_sz = get_image_dim(src1);\n"
"    int2 dst2_sz = get_image_dim(dst2);\n"
"\n"
"    if (xi >= dst2_sz.x || yi >= dst2_sz.y)\n"
"        return;\n"
"\n"
"    float2 src1_sz_recip = native_recip(convert_float2(src1_sz));\n"
"    float2 ncoords_yuv0 = convert_float2((int2)(x,     y)) * src1_sz_recip;\n"
"    float2 ncoords_yuv1 = convert_float2((int2)(x + 1, y)) * src1_sz_recip;\n"
"    float2 ncoords_yuv2 = convert_float2((int2)(x,     y + 1)) * src1_sz_recip;\n"
"    float2 ncoords_yuv3 = convert_float2((int2)(x + 1, y + 1)) * src1_sz_recip;\n"
"\n"
"    float3 yuv0, yuv1, yuv2, yuv3;\n"
"\n"
"    yuv0.x = read_imagef(src1, sampler, (int2)(x,     y)).x;\n"
"    yuv1.x = read_imagef(src1, sampler, (int2)(x + 1, y)).x;\n"
"    yuv2.x = read_imagef(src1, sampler, (int2)(x,     y + 1)).x;\n"
"    yuv3.x = read_imagef(src1, sampler, (int2)(x + 1, y + 1)).x;\n"
"\n"
"#ifdef NON_SEMI_PLANAR_IN\n"
"    yuv0.yz = (float2)(read_imagef(src2, l_sampler, ncoords_yuv0).x,\n"
"                       read_imagef(src3, l_sampler, ncoords_yuv0).x);\n"
"    yuv1.yz = (float2)(read_imagef(src2, l_sampler, ncoords_yuv1).x,\n"
"                       read_imagef(src3, l_sampler, ncoords_yuv1).x);\n"
"    yuv2.yz = (float2)(read_imagef(src2, l_sampler, ncoords_yuv2).x,\n"
"                       read_imagef(src3, l_sampler, ncoords_yuv2).x);\n"
"    yuv3.yz = (float2)(read_imagef(src2, l_sampler, ncoords_yuv3).x,\n"
"                       read_imagef(src3, l_sampler, ncoords_yuv3).x);\n"
"#else\n"
"    yuv0.yz = read_imagef(src2, l_sampler, ncoords_yuv0).xy;\n"
"    yuv1.yz = read_imagef(src2, l_sampler, ncoords_yuv1).xy;\n"
"    yuv2.yz = read_imagef(src2, l_sampler, ncoords_yuv2).xy;\n"
"    yuv3.yz = read_imagef(src2, l_sampler, ncoords_yuv3).xy;\n"
"#endif\n"
"\n"
"#ifdef DOVI_RESHAPE\n"
"    __global const vec *dovi_params = dovi_buf;\n"
"    __global const vec *dovi_pivots = dovi_buf + 24;\n"
"    __global const vec4 *dovi_coeffs = (__global const vec4 *)(dovi_buf + 48);\n"
"    __global const vec4 *dovi_mmr = (__global const vec4 *)(dovi_buf + 144);\n"
"  #ifdef IS_QCOM_GPU\n"
"    reshape_dovi_ipt(&yuv0, dovi_params, dovi_pivots, dovi_coeffs, dovi_mmr);\n"
"    reshape_dovi_ipt(&yuv1, dovi_params, dovi_pivots, dovi_coeffs, dovi_mmr);\n"
"    reshape_dovi_ipt(&yuv2, dovi_params, dovi_pivots, dovi_coeffs, dovi_mmr);\n"
"    reshape_dovi_ipt(&yuv3, dovi_params, dovi_pivots, dovi_coeffs, dovi_mmr);\n"
"  #else\n"
"    reshape_dovi_iptx4(&yuv0, &yuv1, &yuv2, &yuv3, dovi_params, dovi_pivots, dovi_coeffs, dovi_mmr);\n"
"  #endif\n"
"#endif\n"
"\n"
"    float3 c0, c1, c2, c3;\n"
"#ifndef MAP_IN_DST_SPACE\n"
"    c0 = map_to_src_space_from_yuv(yuv0);\n"
"    c1 = map_to_src_space_from_yuv(yuv1);\n"
"    c2 = map_to_src_space_from_yuv(yuv2);\n"
"    c3 = map_to_src_space_from_yuv(yuv3);\n"
"#else\n"
"    c0 = map_to_dst_space_from_yuv(yuv0);\n"
"    c1 = map_to_dst_space_from_yuv(yuv1);\n"
"    c2 = map_to_dst_space_from_yuv(yuv2);\n"
"    c3 = map_to_dst_space_from_yuv(yuv3);\n"
"#endif\n"
"\n"
"#ifndef SKIP_TONEMAP\n"
"    float4 r4 = (float4)(c0.x, c1.x, c2.x, c3.x);\n"
"    float4 g4 = (float4)(c0.y, c1.y, c2.y, c3.y);\n"
"    float4 b4 = (float4)(c0.z, c1.z, c2.z, c3.z);\n"
"  #ifdef TONE_MODE_ITP\n"
"    map_four_pixels_itp(&r4, &g4, &b4, peak);\n"
"  #else\n"
"    map_four_pixels_rgb(&r4, &g4, &b4, peak);\n"
"  #endif\n"
"    c0 = (float3)(r4.x, g4.x, b4.x);\n"
"    c1 = (float3)(r4.y, g4.y, b4.y);\n"
"    c2 = (float3)(r4.z, g4.z, b4.z);\n"
"    c3 = (float3)(r4.w, g4.w, b4.w);\n"
"#endif\n"
"\n"
"#ifndef MAP_IN_DST_SPACE\n"
"    c0 = lrgb2lrgb(c0);\n"
"    c1 = lrgb2lrgb(c1);\n"
"    c2 = lrgb2lrgb(c2);\n"
"    c3 = lrgb2lrgb(c3);\n"
"  #if !defined(RGB2RGB_PASSTHROUGH)\n"
"    c0 = gamut_compress(c0);\n"
"    c1 = gamut_compress(c1);\n"
"    c2 = gamut_compress(c2);\n"
"    c3 = gamut_compress(c3);\n"
"  #endif\n"
"    c0 = clamp(c0, 0.0f, 1.0f);\n"
"    c1 = clamp(c1, 0.0f, 1.0f);\n"
"    c2 = clamp(c2, 0.0f, 1.0f);\n"
"    c3 = clamp(c3, 0.0f, 1.0f);\n"
"#endif\n"
"\n"
"    float y0 = lrgb2y(c0);\n"
"    float y1 = lrgb2y(c1);\n"
"    float y2 = lrgb2y(c2);\n"
"    float y3 = lrgb2y(c3);\n"
"\n"
"#if defined(ENABLE_DITHER) && !defined(SKIP_TONEMAP)\n"
"    int2 dither_sz = get_image_dim(dither);\n"
"    float2 dither_sz_recip = native_recip(convert_float2(dither_sz));\n"
"    float2 ncoords_d = convert_float2((int2)(xi, yi)) * dither_sz_recip;\n"
"    float d = read_imagef(dither, d_sampler, ncoords_d).x;\n"
"    y0 = get_dithered_y(y0, d), y1 = get_dithered_y(y1, d);\n"
"    y2 = get_dithered_y(y2, d), y3 = get_dithered_y(y3, d);\n"
"#endif\n"
"\n"
"    float3 chroma_c = get_chroma_sample(c0, c1, c2, c3);\n"
"    float3 chroma = lrgb2yuv(chroma_c);\n"
"\n"
"    write_imagef(dst1, (int2)(x,     y), (float4)(y0, 0.0f, 0.0f, 1.0f));\n"
"    write_imagef(dst1, (int2)(x + 1, y), (float4)(y1, 0.0f, 0.0f, 1.0f));\n"
"    write_imagef(dst1, (int2)(x,     y + 1), (float4)(y2, 0.0f, 0.0f, 1.0f));\n"
"    write_imagef(dst1, (int2)(x + 1, y + 1), (float4)(y3, 0.0f, 0.0f, 1.0f));\n"
"#ifdef NON_SEMI_PLANAR_OUT\n"
"    write_imagef(dst2, (int2)(xi, yi), (float4)(chroma.y, 0.0f, 0.0f, 1.0f));\n"
"    write_imagef(dst3, (int2)(xi, yi), (float4)(chroma.z, 0.0f, 0.0f, 1.0f));\n"
"#else\n"
"    write_imagef(dst2, (int2)(xi, yi), (float4)(chroma.y, chroma.z, 0.0f, 1.0f));\n"
"#endif\n"
"}\n"
"\n"
"float3 apply_lut3d(__global const float3 *restrict lut, float3 color)\n"
"{\n"
"    color = clamp(color, 0.0f, 1.0f);\n"
"\n"
"    // Scale the color to the LUT grid.\n"
"    float3 pos = color * (float)(LUT_SIZE - 1);\n"
"\n"
"    // Get the integer base indices in the LUT.\n"
"    int3 base = convert_int3(floor(pos));\n"
"    // Compute the fractional part within the cell.\n"
"    float3 f = pos - convert_float3(base);\n"
"\n"
"    // Compute the base linear index.\n"
"    uint base_idx = base.x + base.y * LUT_SIZE + base.z * LUT_SIZE * LUT_SIZE;\n"
"\n"
"    // Sort the fraction offsets, so that we always have a>=b>=c\n"
"    float a = fmax(f.x, fmax(f.y, f.z));\n"
"    float c = fmin(f.x, fmin(f.y, f.z));\n"
"    float b = f.x + f.y + f.z - a - c;\n"
"\n"
"#define LUT_IDX_MAX (LUT_SIZE * LUT_SIZE * LUT_SIZE - 1)\n"
"\n"
"    // The initial and the last corner values of current cube will always be fetched\n"
"    float3 c000 = lut[min(base_idx, (uint)LUT_IDX_MAX)];\n"
"    float3 c111 = lut[min(base_idx + 1 + LUT_SIZE + LUT_SIZE * LUT_SIZE, (uint)LUT_IDX_MAX)];\n"
"\n"
"    // Select the index for vertices of the tetrahedron.\n"
"    uint idx100 = base_idx + 1;\n"
"    uint idx010 = base_idx + LUT_SIZE;\n"
"    uint idx110 = base_idx + 1 + LUT_SIZE;\n"
"    uint idx001 = base_idx + LUT_SIZE * LUT_SIZE;\n"
"    uint idx101 = base_idx + 1 + LUT_SIZE * LUT_SIZE;\n"
"    uint idx011 = base_idx + LUT_SIZE + LUT_SIZE * LUT_SIZE;\n"
"\n"
"    // Although we have a and c as max and min value, we cannot use them in the\n"
"    // following selection as float equality comparison is not accurate on GPU.\n"
"    uint idx0 = select(select(idx001, idx010, (f.y >= f.z && f.y >= f.x)), idx100, (f.x >= f.y && f.x >= f.z));\n"
"    uint idx1 = select(select(idx110, idx101, (f.y <= f.z && f.y <= f.x)), idx011, (f.x <= f.y && f.x <= f.z));\n"
"\n"
"    // Fetch LUT value with determined tetrahedron\n"
"    float3 c0 = lut[min(idx0, (uint)LUT_IDX_MAX)];\n"
"    float3 c1 = lut[min(idx1, (uint)LUT_IDX_MAX)];\n"
"\n"
"    float3 ca = c0 - c000;\n"
"    float3 cb = c1 - c0;\n"
"    float3 cc = c111 - c1;\n"
"\n"
"    float3 result = c000 + a * ca + b * cb + c * cc;\n"
"\n"
"    return clamp(result, 0.0f, 1.0f);\n"
"}\n"
"\n"
"__kernel void tonemap_lut(__global const float3 *restrict lut,\n"
"                          __write_only image2d_t dst1,\n"
"                          __read_only  image2d_t src1,\n"
"                          __write_only image2d_t dst2,\n"
"                          __read_only  image2d_t src2,\n"
"#ifdef NON_SEMI_PLANAR_OUT\n"
"                          __write_only image2d_t dst3,\n"
"#endif\n"
"#ifdef NON_SEMI_PLANAR_IN\n"
"                          __read_only  image2d_t src3,\n"
"#endif\n"
"#ifdef ENABLE_DITHER\n"
"                          __read_only  image2d_t dither,\n"
"#endif\n"
"#ifdef DOVI_RESHAPE\n"
"                          __global const vec *restrict dovi_buf,\n"
"#endif\n"
"                          float peak)\n"
"{\n"
"    int xi = get_global_id(0);\n"
"    int yi = get_global_id(1);\n"
"    // each work item process four pixels\n"
"    int x = xi << 1;\n"
"    int y = yi << 1;\n"
"\n"
"    int2 src1_sz = get_image_dim(src1);\n"
"    int2 dst2_sz = get_image_dim(dst2);\n"
"\n"
"    if (xi >= dst2_sz.x || yi >= dst2_sz.y)\n"
"        return;\n"
"\n"
"    float2 src1_sz_recip = native_recip(convert_float2(src1_sz));\n"
"    float2 ncoords_yuv0 = convert_float2((int2)(x,     y)) * src1_sz_recip;\n"
"    float2 ncoords_yuv1 = convert_float2((int2)(x + 1, y)) * src1_sz_recip;\n"
"    float2 ncoords_yuv2 = convert_float2((int2)(x,     y + 1)) * src1_sz_recip;\n"
"    float2 ncoords_yuv3 = convert_float2((int2)(x + 1, y + 1)) * src1_sz_recip;\n"
"\n"
"    float3 yuv0, yuv1, yuv2, yuv3;\n"
"\n"
"    yuv0.x = read_imagef(src1, sampler, (int2)(x,     y)).x;\n"
"    yuv1.x = read_imagef(src1, sampler, (int2)(x + 1, y)).x;\n"
"    yuv2.x = read_imagef(src1, sampler, (int2)(x,     y + 1)).x;\n"
"    yuv3.x = read_imagef(src1, sampler, (int2)(x + 1, y + 1)).x;\n"
"\n"
"#ifdef NON_SEMI_PLANAR_IN\n"
"    yuv0.yz = (float2)(read_imagef(src2, l_sampler, ncoords_yuv0).x,\n"
"                       read_imagef(src3, l_sampler, ncoords_yuv0).x);\n"
"    yuv1.yz = (float2)(read_imagef(src2, l_sampler, ncoords_yuv1).x,\n"
"                       read_imagef(src3, l_sampler, ncoords_yuv1).x);\n"
"    yuv2.yz = (float2)(read_imagef(src2, l_sampler, ncoords_yuv2).x,\n"
"                       read_imagef(src3, l_sampler, ncoords_yuv2).x);\n"
"    yuv3.yz = (float2)(read_imagef(src2, l_sampler, ncoords_yuv3).x,\n"
"                       read_imagef(src3, l_sampler, ncoords_yuv3).x);\n"
"#else\n"
"    yuv0.yz = read_imagef(src2, l_sampler, ncoords_yuv0).xy;\n"
"    yuv1.yz = read_imagef(src2, l_sampler, ncoords_yuv1).xy;\n"
"    yuv2.yz = read_imagef(src2, l_sampler, ncoords_yuv2).xy;\n"
"    yuv3.yz = read_imagef(src2, l_sampler, ncoords_yuv3).xy;\n"
"#endif\n"
"\n"
"#ifdef DOVI_RESHAPE\n"
"    __global const vec *dovi_params = dovi_buf;\n"
"    __global const vec *dovi_pivots = dovi_buf + 24;\n"
"    __global const vec4 *dovi_coeffs = (__global const vec4 *)(dovi_buf + 48);\n"
"    __global const vec4 *dovi_mmr = (__global const vec4 *)(dovi_buf + 144);\n"
"  #ifdef IS_QCOM_GPU\n"
"    reshape_dovi_ipt(&yuv0, dovi_params, dovi_pivots, dovi_coeffs, dovi_mmr);\n"
"    reshape_dovi_ipt(&yuv1, dovi_params, dovi_pivots, dovi_coeffs, dovi_mmr);\n"
"    reshape_dovi_ipt(&yuv2, dovi_params, dovi_pivots, dovi_coeffs, dovi_mmr);\n"
"    reshape_dovi_ipt(&yuv3, dovi_params, dovi_pivots, dovi_coeffs, dovi_mmr);\n"
"  #else\n"
"    reshape_dovi_iptx4(&yuv0, &yuv1, &yuv2, &yuv3, dovi_params, dovi_pivots, dovi_coeffs, dovi_mmr);\n"
"  #endif\n"
"#endif\n"
"\n"
"    float3 c0, c1, c2, c3;\n"
"\n"
"    c0 = apply_lut3d(lut, yuv0);\n"
"    c1 = apply_lut3d(lut, yuv1);\n"
"    c2 = apply_lut3d(lut, yuv2);\n"
"    c3 = apply_lut3d(lut, yuv3);\n"
"\n"
"    float3 chroma = get_chroma_sample(c0, c1, c2, c3);\n"
"\n"
"    write_imagef(dst1, (int2)(x,     y), (float4)(c0.x, 0.0f, 0.0f, 1.0f));\n"
"    write_imagef(dst1, (int2)(x + 1, y), (float4)(c1.x, 0.0f, 0.0f, 1.0f));\n"
"    write_imagef(dst1, (int2)(x,     y + 1), (float4)(c2.x, 0.0f, 0.0f, 1.0f));\n"
"    write_imagef(dst1, (int2)(x + 1, y + 1), (float4)(c3.x, 0.0f, 0.0f, 1.0f));\n"
"#ifdef NON_SEMI_PLANAR_OUT\n"
"    write_imagef(dst2, (int2)(xi, yi), (float4)(chroma.y, 0.0f, 0.0f, 1.0f));\n"
"    write_imagef(dst3, (int2)(xi, yi), (float4)(chroma.z, 0.0f, 0.0f, 1.0f));\n"
"#else\n"
"    write_imagef(dst2, (int2)(xi, yi), (float4)(chroma.y, chroma.z, 0.0f, 1.0f));\n"
"#endif\n"
"}\n"
"\n"
"__kernel void build_lut(__global float3 *lut, float peak)\n"
"{\n"
"    const int total_entries = LUT_SIZE * LUT_SIZE * LUT_SIZE;\n"
"    int idx = get_global_id(0);\n"
"    if (idx >= total_entries) return;\n"
"    int z = idx / (LUT_SIZE * LUT_SIZE);\n"
"    int rem = idx - (z * LUT_SIZE * LUT_SIZE);\n"
"    int y = rem / LUT_SIZE;\n"
"    int x = rem % LUT_SIZE;\n"
"    float fx = (float)x / (LUT_SIZE - 1);\n"
"    float fy = (float)y / (LUT_SIZE - 1);\n"
"    float fz = (float)z / (LUT_SIZE - 1);\n"
"    float3 c = (float3)(fx, fy, fz);\n"
"#ifndef MAP_IN_DST_SPACE\n"
"    c = map_to_src_space_from_yuv(c);\n"
"#else\n"
"    c = map_to_dst_space_from_yuv(c);\n"
"#endif\n"
"    float4 r4 = (float4)(c.x, c.x, c.x, c.x);\n"
"    float4 g4 = (float4)(c.y, c.y, c.y, c.y);\n"
"    float4 b4 = (float4)(c.z, c.z, c.z, c.z);\n"
"#ifndef SKIP_TONEMAP\n"
"  #ifdef TONE_MODE_ITP\n"
"    map_four_pixels_itp(&r4, &g4, &b4, peak);\n"
"  #else\n"
"    map_four_pixels_rgb(&r4, &g4, &b4, peak);\n"
"  #endif\n"
"#endif\n"
"    c = (float3)(r4.x, g4.x, b4.x);\n"
"#ifndef MAP_IN_DST_SPACE\n"
"    c = lrgb2lrgb(c);\n"
"  #ifndef RGB2RGB_PASSTHROUGH\n"
"    c = gamut_compress(c);\n"
"  #endif\n"
"    c = clamp(c, 0.0f, 1.0f);\n"
"#endif\n"
"    c = lrgb2yuv(c);\n"
"    lut[idx] = clamp(c, 0.0f, 1.0f);\n"
"}\n"
;
