// Generated from libavfilter/opencl/yadif.cl
const char *ff_source_yadif_cl =
"/*\n"
" * Copyright (C) 2018 Philip Langdale <philipl@overt.org>\n"
" *               2025 NyanMisaka\n"
" *\n"
" * This file is part of FFmpeg.\n"
" *\n"
" * FFmpeg is free software; you can redistribute it and/or\n"
" * modify it under the terms of the GNU Lesser General Public\n"
" * License as published by the Free Software Foundation; either\n"
" * version 2.1 of the License, or (at your option) any later version.\n"
" *\n"
" * FFmpeg is distributed in the hope that it will be useful,\n"
" * but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU\n"
" * Lesser General Public License for more details.\n"
" *\n"
" * You should have received a copy of the GNU Lesser General Public\n"
" * License along with FFmpeg; if not, write to the Free Software\n"
" * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA\n"
" */\n"
"\n"
"#define max3(a, b, c) max(max((a), (b)), (c))\n"
"#define min3(a, b, c) min(min((a), (b)), (c))\n"
"\n"
"__constant sampler_t sampler = (CLK_NORMALIZED_COORDS_FALSE |\n"
"                                CLK_ADDRESS_CLAMP_TO_EDGE   |\n"
"                                CLK_FILTER_NEAREST);\n"
"\n"
"inline float spatial_predictor_float(float a, float b, float c, float d, float e, float f, float g,\n"
"                                     float h, float i, float j, float k, float l, float m, float n)\n"
"{\n"
"    float spatial_pred = (d + k) * 0.5f;\n"
"    float spatial_score = fabs(c - j) + fabs(d - k) + fabs(e - l);\n"
"\n"
"    float score = fabs(b - k) + fabs(c - l) + fabs(d - m);\n"
"    if (score < spatial_score) {\n"
"        spatial_pred = (c + l) * 0.5f;\n"
"        spatial_score = score;\n"
"        score = fabs(a - l) + fabs(b - m) + fabs(c - n);\n"
"        if (score < spatial_score) {\n"
"            spatial_pred = (b + m) * 0.5f;\n"
"            spatial_score = score;\n"
"        }\n"
"    }\n"
"    score = fabs(d - i) + fabs(e - j) + fabs(f - k);\n"
"    if (score < spatial_score) {\n"
"        spatial_pred = (e + j) * 0.5f;\n"
"        spatial_score = score;\n"
"        score = fabs(e - h) + fabs(f - i) + fabs(g - j);\n"
"        if (score < spatial_score) {\n"
"            spatial_pred = (f + i) * 0.5f;\n"
"            spatial_score = score;\n"
"        }\n"
"    }\n"
"    return spatial_pred;\n"
"}\n"
"\n"
"inline float2 spatial_predictor_float2(float2 a, float2 b, float2 c, float2 d, float2 e, float2 f, float2 g,\n"
"                                       float2 h, float2 i, float2 j, float2 k, float2 l, float2 m, float2 n)\n"
"{\n"
"    return (float2)(spatial_predictor_float(a.x, b.x, c.x, d.x, e.x, f.x, g.x,\n"
"                                            h.x, i.x, j.x, k.x, l.x, m.x, n.x),\n"
"                    spatial_predictor_float(a.y, b.y, c.y, d.y, e.y, f.y, g.y,\n"
"                                            h.y, i.y, j.y, k.y, l.y, m.y, n.y));\n"
"}\n"
"\n"
"\n"
"inline float temporal_predictor_float(float A, float B, float C, float D, float E, float F,\n"
"                                      float G, float H, float I, float J, float K, float L,\n"
"                                      float spatial_pred, bool skip_check)\n"
"{\n"
"    float p0 = (C + H) * 0.5f;\n"
"    float p1 = F;\n"
"    float p2 = (D + I) * 0.5f;\n"
"    float p3 = G;\n"
"    float p4 = (E + J) * 0.5f;\n"
"\n"
"    float tdiff0 = fabs(D - I);\n"
"    float tdiff1 = (fabs(A - F) + fabs(B - G)) * 0.5f;\n"
"    float tdiff2 = (fabs(K - F) + fabs(G - L)) * 0.5f;\n"
"\n"
"    float diff = max3(tdiff0, tdiff1, tdiff2);\n"
"\n"
"    if (!skip_check) {\n"
"        float maxi = max3(p2 - p3, p2 - p1, min(p0 - p1, p4 - p3));\n"
"        float mini = min3(p2 - p3, p2 - p1, max(p0 - p1, p4 - p3));\n"
"        diff = max3(diff, mini, -maxi);\n"
"    }\n"
"    return clamp(spatial_pred, p2 - diff, p2 + diff);\n"
"}\n"
"\n"
"inline float2 temporal_predictor_float2(float2 A, float2 B, float2 C, float2 D, float2 E, float2 F,\n"
"                                        float2 G, float2 H, float2 I, float2 J, float2 K, float2 L,\n"
"                                        float2 spatial_pred, bool skip_check)\n"
"{\n"
"    return (float2)(temporal_predictor_float(A.x, B.x, C.x, D.x, E.x, F.x,\n"
"                                             G.x, H.x, I.x, J.x, K.x, L.x,\n"
"                                             spatial_pred.x, skip_check),\n"
"                    temporal_predictor_float(A.y, B.y, C.y, D.y, E.y, F.y,\n"
"                                             G.y, H.y, I.y, J.y, K.y, L.y,\n"
"                                             spatial_pred.y, skip_check));\n"
"}\n"
"\n"
"#define YADIF_COMPUTE_SPATIAL(T, XY) \\\n"
"inline T yadif_compute_spatial_##T(__read_only image2d_t cur, int2 pos) \\\n"
"{ \\\n"
"    T a = read_imagef(cur, sampler, (int2)(pos.x - 3, pos.y - 1)).XY; \\\n"
"    T b = read_imagef(cur, sampler, (int2)(pos.x - 2, pos.y - 1)).XY; \\\n"
"    T c = read_imagef(cur, sampler, (int2)(pos.x - 1, pos.y - 1)).XY; \\\n"
"    T d = read_imagef(cur, sampler, (int2)(pos.x - 0, pos.y - 1)).XY; \\\n"
"    T e = read_imagef(cur, sampler, (int2)(pos.x + 1, pos.y - 1)).XY; \\\n"
"    T f = read_imagef(cur, sampler, (int2)(pos.x + 2, pos.y - 1)).XY; \\\n"
"    T g = read_imagef(cur, sampler, (int2)(pos.x + 3, pos.y - 1)).XY; \\\n"
"    T h = read_imagef(cur, sampler, (int2)(pos.x - 3, pos.y + 1)).XY; \\\n"
"    T i = read_imagef(cur, sampler, (int2)(pos.x - 2, pos.y + 1)).XY; \\\n"
"    T j = read_imagef(cur, sampler, (int2)(pos.x - 1, pos.y + 1)).XY; \\\n"
"    T k = read_imagef(cur, sampler, (int2)(pos.x - 0, pos.y + 1)).XY; \\\n"
"    T l = read_imagef(cur, sampler, (int2)(pos.x + 1, pos.y + 1)).XY; \\\n"
"    T m = read_imagef(cur, sampler, (int2)(pos.x + 2, pos.y + 1)).XY; \\\n"
"    T n = read_imagef(cur, sampler, (int2)(pos.x + 3, pos.y + 1)).XY; \\\n"
"    return spatial_predictor_##T(a, b, c, d, e, f, g, \\\n"
"                                 h, i, j, k, l, m, n); \\\n"
"}\n"
"\n"
"#define YADIF_COMPUTE_TEMPORAL(T, XY) \\\n"
"inline T yadif_compute_temporal_##T(__read_only image2d_t cur, \\\n"
"                                    __read_only image2d_t prev2, \\\n"
"                                    __read_only image2d_t prev1, \\\n"
"                                    __read_only image2d_t next1, \\\n"
"                                    __read_only image2d_t next2, \\\n"
"                                    T spatial_pred, \\\n"
"                                    bool skip_spatial_check, \\\n"
"                                    int2 pos) \\\n"
"{ \\\n"
"    T A = read_imagef(prev2, sampler, (int2)(pos.x, pos.y - 1)).XY; \\\n"
"    T B = read_imagef(prev2, sampler, (int2)(pos.x, pos.y + 1)).XY; \\\n"
"    T C = read_imagef(prev1, sampler, (int2)(pos.x, pos.y - 2)).XY; \\\n"
"    T D = read_imagef(prev1, sampler, (int2)(pos.x, pos.y + 0)).XY; \\\n"
"    T E = read_imagef(prev1, sampler, (int2)(pos.x, pos.y + 2)).XY; \\\n"
"    T F = read_imagef(cur,   sampler, (int2)(pos.x, pos.y - 1)).XY; \\\n"
"    T G = read_imagef(cur,   sampler, (int2)(pos.x, pos.y + 1)).XY; \\\n"
"    T H = read_imagef(next1, sampler, (int2)(pos.x, pos.y - 2)).XY; \\\n"
"    T I = read_imagef(next1, sampler, (int2)(pos.x, pos.y + 0)).XY; \\\n"
"    T J = read_imagef(next1, sampler, (int2)(pos.x, pos.y + 2)).XY; \\\n"
"    T K = read_imagef(next2, sampler, (int2)(pos.x, pos.y - 1)).XY; \\\n"
"    T L = read_imagef(next2, sampler, (int2)(pos.x, pos.y + 1)).XY; \\\n"
"    return temporal_predictor_##T(A, B, C, D, E, F, G, H, I, J, K, L, \\\n"
"                                  spatial_pred, skip_spatial_check); \\\n"
"}\n"
"\n"
"YADIF_COMPUTE_SPATIAL(float, x)\n"
"YADIF_COMPUTE_TEMPORAL(float, x)\n"
"YADIF_COMPUTE_SPATIAL(float2, xy)\n"
"YADIF_COMPUTE_TEMPORAL(float2, xy)\n"
"\n"
"__kernel void yadif(__write_only image2d_t dst,\n"
"                    __read_only  image2d_t prev,\n"
"                    __read_only  image2d_t cur,\n"
"                    __read_only  image2d_t next,\n"
"                    int channels,\n"
"                    int parity,\n"
"                    int is_second_field,\n"
"                    int skip_spatial_check)\n"
"{\n"
"    int2 pos = (int2)(get_global_id(0), get_global_id(1));\n"
"\n"
"    if (pos.x >= get_image_width(dst) ||\n"
"        pos.y >= get_image_height(dst))\n"
"        return;\n"
"\n"
"    // Don't modify the primary field\n"
"    if (pos.y % 2 == parity) {\n"
"        float4 in = read_imagef(cur, sampler, pos);\n"
"        write_imagef(dst, pos, in);\n"
"        return;\n"
"    }\n"
"\n"
"    if (channels == 1) {\n"
"        float spatial_pred = yadif_compute_spatial_float(cur, pos);\n"
"        float pred = is_second_field\n"
"            ? yadif_compute_temporal_float(cur, prev, cur, next, next,\n"
"                                           spatial_pred, skip_spatial_check, pos)\n"
"            : yadif_compute_temporal_float(cur, prev, prev, cur, next,\n"
"                                           spatial_pred, skip_spatial_check, pos);\n"
"\n"
"        write_imagef(dst, pos, (float4)(pred, 0.0f, 0.0f, 1.0f));\n"
"    } else if (channels == 2) {\n"
"        float2 spatial_pred = yadif_compute_spatial_float2(cur, pos);\n"
"        float2 pred = is_second_field\n"
"            ? yadif_compute_temporal_float2(cur, prev, cur, next, next,\n"
"                                            spatial_pred, skip_spatial_check, pos)\n"
"            : yadif_compute_temporal_float2(cur, prev, prev, cur, next,\n"
"                                            spatial_pred, skip_spatial_check, pos);\n"
"\n"
"        write_imagef(dst, pos, (float4)(pred.x, pred.y, 0.0f, 1.0f));\n"
"    }\n"
"}\n"
;
